#!/usr/bin/perl
use Socket;
use Mysql;

#    RingWorld SQL v1.9 - webring management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

# Variables Section
open (F, "<rworld.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);

######################################################################
# Main Section                                                       #
######################################################################
# Get data
if ($ENV{CONTENT_LENGTH}>0){read(STDIN,$data,$ENV{CONTENT_LENGTH});}
else {($data=$ENV{QUERY_STRING});}
@data=split("&",$data);
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex ($1))/eg;
		$data{$field}=$value;
	}
}

# Autorization
$sth=$dbh->query("LOCK TABLES rw_users READ") if ($locktables);
$sth=$dbh->query("SELECT uid,status,email,name FROM rw_users WHERE (username='$data{name}' AND password='$data{password}' AND acctype=1)");
($uid,$status,$email,$ownername)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if (!$uid)
{
	push(@errors,"Incorrect username or password<br>");
	&error(@errors);
}
if (!$status)
{
	push(@errors,"Your account is not approved yet<br>");
	&error(@errors);
}
if ($status==2)
{
	push(@errors,"Your account is disabled<br>");
	&error(@errors);
}
$destination=$data{method};
&$destination;

sub genset
{
$selected{genset}="selected";
$sth=$dbh->query("LOCK TABLES rw_rings READ") if ($locktables);
$sth=$dbh->query("SELECT rname,rurl,rdescr,caid FROM rw_rings WHERE uid=$uid");
($rname,$rurl,$rdescr,$rcaid)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$rdescr=~s/\<br\>/\n/gi;
$sth=$dbh->query("LOCK TABLES rw_categories READ") if ($locktables);
$sth=$dbh->query("SELECT caid,category,subcategory FROM rw_categories ORDER BY category,subcategory");
while (($caid,$category,$subcategory)=$sth->fetchrow)
{
	if ($caid==$rcaid)
	{
		$cats.="<option value=\"$caid\" selected>$category:$subcategory</option>\n";
	}
	else
	{
		$cats.="<option value=\"$caid\">$category:$subcategory</option>\n";
	}
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$result=qq~
<tr><td><form action="$cgi/rwowner.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="chgenset">
<table cellpadding=0 cellspacing=0 width="100%">
<tr><td width="100%" colspan=4 bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>CHANGE WEBRING INFORMATION</center></font></td></tr>
<tr><td width="25%"><font face="Arial" size="2">Ringname:</font></td><td width="25%"><input type="text" name="uname" value="$rname" size=15 maxlength=50></td><td width="25%"><font face="Arial" size="2">E-Mail:</font></td><td width="25%"><input type="text" value="$email" name="email" size=15 maxlength=50></td></tr>
<tr><td width="25%"><font face="Arial" size="2">WebRing URL:</font></td><td width="75%" colspan=3 align="right"><input type=text name="wurl" size=55 value="$rurl"></td></tr>
<tr><td width="25%"><font face="Arial" size="2">WebRing description:</font></td><td width="75%" colspan=3 align="right"><textarea name="description" cols=41 rows=4 wrap="virtual">$rdescr</textarea></td></tr>
<tr><td width="25%"><font face="Arial" size="2">Category:</font></td><td width="75%" colspan=3 align="right"><select name="categ">$cats</select></td></tr>
<tr><td width="100%" colspan=4 align="right"><input type="Submit" name="Submit" value="Change"></td></tr>
</table></form></td></tr>
<tr><td>
~;
&closedb;
open(F,"<$rwpath/template/owner.tpl");
@html=<F>;
close(F);
$html=join("",@html);
$html="print qq~$html~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $html;
exit;
}
sub chgenset
{
$sth=$dbh->query("LOCK TABLES rw_rings READ") if ($locktables);
$sth=$dbh->query("SELECT rname,rurl,rdescr,caid FROM rw_rings WHERE uid=$uid");
($rname,$rurl,$rdescr,$rcaid)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$data{description}=~s/\r\n/\<br\>/g;
if ($wurlrequired)
{
	if (($data{wurl} && $data{wurl}!~/^http:\/\//i) || $data{wurl}=~/^http:\/\/$/i || !$data{wurl})
	{
		$data{wurl}=$rurl;
	}
}
else
{
	if (($data{wurl} && $data{wurl}!~/^http:\/\//i) || $data{wurl}=~/^http:\/\/$/i)
	{
		$data{wurl}=$rurl;
	}
}
if (!$data{uname})
{
	$data{uname}=$rname;
}
if (!$data{email})
{
	$data{email}=$email;
}
else
{
	$email=$data{email};
}
if (!$data{categ})
{
	$data{categ}=$rcaid;
}
$data{uname}=~s/'/\\'/g;
$data{description}=~s/'/\\'/g;
$sth=$dbh->query("LOCK TABLES rw_rings WRITE, rw_users WRITE") if ($locktables);
$sth=$dbh->query("UPDATE rw_rings SET rname='$data{uname}',rurl='$data{wurl}',rdescr='$data{description}',caid=$data{categ} WHERE uid=$uid");
$sth=$dbh->query("UPDATE rw_users SET email='$data{email}' WHERE uid=$uid");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&genset;
}
sub logo
{
$selected{logo}="selected";
$sth=$dbh->query("LOCK TABLES rw_rings READ") if ($locktables);
$sth=$dbh->query("SELECT rid FROM rw_rings WHERE (uid=$uid)");
$rid=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if (-e "$rwpath/logo/$rid.gif")
{
srand;
$random=rand;
$logo=qq~
<TABLE><TR><TD>
<img src="$ringworld/logo/$uid.gif?$random"><BR><BR>
</TD></TR><TR><TD ALIGN=CENTER>
<form action="$cgi/rwowner.pl" method="post">
<input type="hidden" name="name" value="$data{name}">
<input type="hidden" name="password" value="$data{password}">
<input type="hidden" name="method" value="logoremove">
<input type="Submit" value="Remove">
</form></TD></TR><TR><TD ALIGN=CENTER>
<font face="Arial" size=2>and use the default logo for webring</font>
</TD></TR></TABLE>
~;
}
else {$logo="<img src=\"$ringworld/images/rwban.gif\">";}
$result=qq~
<tr><td>
<form action="$cgi/rwupload.pl" method="post" enctype="multipart/form-data"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}">
<table cellpadding=0 cellspacing=0 width="100%">
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>UPLOAD LOGO</center></font></td></tr>
<tr><td><font face="Arial" size="2"><input type="file" name="UploadBanner" size=43><br>Your logo must be GIF</font></td></tr>
<tr><td width="100%" align="right"><font face="Arial" size="2"><input type="Submit" value="Upload"></font></td></tr>
</table></form></td></tr>
<tr><td align=center><font size=2>YOUR CURRENT LOGO:<br>$logo</font></td></tr>
~;
&closedb;
open(F,"<$rwpath/template/owner.tpl");
@html=<F>;
close(F);
$html=join("",@html);
$html="print qq~$html~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $html;
exit;
}
sub remove
{
if ($data{user})
{
$sth=$dbh->query("LOCK TABLES rw_sites READ, rw_rings READ") if ($locktables);
$sth=$dbh->query("SELECT rid,rname FROM rw_rings WHERE uid=$uid");
($rid,$rname)=$sth->fetchrow;
$sth=$dbh->query("SELECT sid FROM rw_sites WHERE (uid=$data{user} AND rid=$rid)");
$sid=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if ($sid)
{
	$sth=$dbh->query("LOCK TABLES rw_users WRITE, rw_sites WRITE") if ($locktables);
	$sth=$dbh->query("SELECT email,name FROM rw_users WHERE uid=$data{user}");
	($uemail,$uname)=$sth->fetchrow;
	$sth=$dbh->query("DELETE FROM rw_users WHERE uid=$data{user}");
	$sth=$dbh->query("DELETE FROM rw_sites WHERE uid=$data{user}");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
open (MAIL,"|$mailprog");
print MAIL "To: $uemail ($uname)\n";
print MAIL "From: $email ($ownername)\n";
print MAIL "Subject: Alert\n\n";
$ltime=scalar localtime;
$sth=$dbh->query("LOCK TABLES rw_settings READ") if ($locktables);
$sth=$dbh->query("SELECT leader_site_remove,mail_header,mail_footer FROM rw_settings");
($text,$header,$footer)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$text="print MAIL \"$text\";";
print MAIL "$header\n";
eval $text;
print MAIL "$footer\n";
print MAIL "\n.\n";
close (MAIL);
}
&list;
}
sub edit
{
$selected{list}="selected";
if ($data{user})
{
$sth=$dbh->query("LOCK TABLES rw_sites READ, rw_rings READ") if ($locktables);
$sth=$dbh->query("SELECT rid,rname FROM rw_rings WHERE uid=$uid");
($rid,$rname)=$sth->fetchrow;
$sth=$dbh->query("SELECT sid FROM rw_sites WHERE (uid=$data{user} AND rid=$rid)");
$sid=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if ($sid)
{
	$sth=$dbh->query("LOCK TABLES rw_sites READ, rw_users READ") if ($locktables);
	$sth=$dbh->query("SELECT sname,surl,sdescr,status,email FROM rw_users,rw_sites WHERE (rw_sites.uid=$data{user} AND rw_sites.uid=rw_users.uid)");
	($tit,$url,$desc,$iflg,$ueml)=$sth->fetchrow;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	$desc=~s/\<br\>/\n/g;
	$selected[$iflg]="selected";
	$result=qq~
	<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>CHANGE USERDATA</center></font></td></tr>
	<tr><td width="100%"><font face="Arial" size="2"><form action="$cgi/rwowner.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="user" value="$data{user}"><input type="hidden" name="method" value="chedit">
	<input type="text" name="title" value="$tit" size=38 maxlength=100> - Title<br>
	<input type="text" name="url" value="$url" size=38 maxlength=100> - URL<br>
	<input type="text" name="email" value="$ueml" size=38 maxlength=100> - Email<br>
	<select name="status"><option value="0" $selected[0]>Not approved</option><option value="1" $selected[1]>Enabled</option><option value="2" $selected[2]>Disabled</option><option value="3" $selected[3]>Suspended</option></select> - Status<br>
	<textarea name="desc" cols=30 rows=3>$desc</textarea> - Description<br>
	<input type="Submit" value="Change data"><br></form></font></td></tr>
	~;
	&closedb;
	open(F,"<$rwpath/template/owner.tpl");
	@html=<F>;
	close(F);
	$html=join("",@html);
	$html="print qq~$html~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $html;
	exit;
}
}
&list;
}
sub jpage
{
$selected{jpage}="selected";
$sth=$dbh->query("LOCK TABLES rw_rings READ") if ($locktables);
$sth=$dbh->query("SELECT rid FROM rw_rings WHERE uid=$uid");
$rid=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$result=qq~
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>JOINING PAGE HTML CODE</center></font></td></tr>
<tr><td width="100%"><font face="Arial" size="2">
<form>
<textarea cols=47 rows=5>
<form action="$cgi/rwsite.pl" method="post">
<input type=hidden name="Wrname" value="$rid">
<table cellpadding="0" cellspacing="0" width="100%">
<tr><td width="100%" colspan="4" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>PERSONAL INFORMATION</center></font></td></tr>
<tr><td width="25%"><font face="Arial" size="2">Name:</font></td><td width="25%"><input type="text" name="Name" size="15" maxlength="50"></td><td width="25%"><font face="Arial" size="2">E-Mail:</font></td><td width="25%"><input type="text" name="Email" size="15" maxlength="50"></td></tr>
<tr><td width="100%" colspan="4" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>SITE INFORMATION</center></font></td></tr>
<tr><td width="25%"><font face="Arial" size="2">Site URL:</font></td><td width="75%" colspan="3" align="right"><input type="text" name="URL" size="40" maxlength="100"></td></tr>
<tr><td width="25%"><font face="Arial" size="2">Site title:</font></td><td width="75%" colspan="3" align="right"><input type="text" name="Title" size="40" maxlength="100"></td></tr>
<tr><td width="25%"><font face="Arial" size="2">Site description:</font></td><td width="75%" colspan="3" align="right">&lt;textarea name="Desc" cols=32 rows=3>&lt;/textarea></td></tr>
<tr><td width="100%" colspan="4" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>MEMBER INFORMATION</center></font></td></tr>
<tr><td width="50%" colspan="2"><font face="Arial" size="2">Choose Username:</font></td><td width="50%" colspan="2" align="right"><input type="text" name="Username" size="29"></td></tr>
<tr><td width="50%" colspan="2"><font face="Arial" size="2">Choose Password</font></td><td width="50%" colspan="2" align="right"><input type="text" name="Password" size="29"></td></tr>
<tr><td width="100%" colspan="4" align="right"><input type="Submit" value="Register"><input type="Reset" value="Clear form"></td></tr>
</table>&lt;/form>
</textarea>
</form>
</font></td></tr>
~;
&closedb;
open(F,"<$rwpath/template/owner.tpl");
@html=<F>;
close(F);
$html=join("",@html);
$html="print qq~$html~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $html;
exit;
}
sub chedit
{
$data{desc}=~s/\r\n/\<br\>/g;
$data{desc}=~s/'/\\'/g;
$data{title}=~s/'/\\'/g;
if ($data{user})
{
$sth=$dbh->query("LOCK TABLES rw_sites READ, rw_rings READ") if ($locktables);
$sth=$dbh->query("SELECT rid,rname FROM rw_rings WHERE uid=$uid");
($rid,$rname)=$sth->fetchrow;
$sth=$dbh->query("SELECT sid FROM rw_sites WHERE (uid=$data{user} AND rid=$rid)");
$sid=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if ($sid)
{
	$sth=$dbh->query("LOCK TABLES rw_sites WRITE, rw_users WRITE") if ($locktables);
	$sth=$dbh->query("UPDATE rw_sites SET sname='$data{title}',surl='$data{url}',sdescr='$data{desc}' WHERE uid=$data{user}");
	$sth=$dbh->query("UPDATE rw_users SET status=$data{status},email='$data{email}' WHERE uid=$data{user}");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
}
&list;
}
sub webnew
{
$selected{webnew}="selected";
$sth=$dbh->query("LOCK TABLES rw_rings READ") if ($locktables);
$sth=$dbh->query("SELECT rid FROM rw_rings WHERE uid=$uid");
$rid=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES rw_sites READ, rw_users READ") if ($locktables);
$sth=$dbh->query("SELECT rw_sites.uid,sname,surl,sdescr,email FROM rw_sites,rw_users WHERE (rid=$rid AND status=0 AND rw_sites.uid=rw_users.uid)");
while (($suid,$sname,$url,$sdescr,$uemail)=$sth->fetchrow)
{
	if ($autocheck)
	{
		$status=&checkurl;
		$status="<b>Status:</b> $status";
	}
	else
	{
		$status=qq~<a href="javascript:opwin('$url')"><b>Check Status</b></a>~;
	}
	$result.=qq~<tr><td width="100%"><font face="Arial" size="2"><b>Site:</b> $sname<br><b>URL:</b> <a href="$url" target="_blank">$url</a><br><b>E-mail:</b> <a href="mailto:$uemail">$uemail</a><br><b>Description:</b> $sdescr<br>$status</font><form action="$cgi/rwowner.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="user" value="$suid"><center><input type=submit name=method value=accept><input type=submit name=method value=decline></center></form></td></tr>\n~;
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$result="<tr><td align=center><font size=2>No new sites</font></td></tr>\n" if (!$result);
&closedb;
open(F,"<$rwpath/template/owner.tpl");
@html=<F>;
close(F);
$html=join("",@html);
$html="print qq~$html~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $html;
exit;
}
sub webexist
{
$selected{webexist}="selected";
$sth=$dbh->query("LOCK TABLES rw_rings READ") if ($locktables);
$sth=$dbh->query("SELECT rid FROM rw_rings WHERE uid=$uid");
$rid=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES rw_sites READ, rw_users READ") if ($locktables);
$sth=$dbh->query("SELECT rw_sites.uid,sname,surl,sdescr,email,status FROM rw_sites,rw_users WHERE (rid=$rid AND (status=1 OR status=2 OR status=3) AND rw_sites.uid=rw_users.uid)");
while (($suid,$sname,$url,$sdescr,$uemail,$accstatus)=$sth->fetchrow)
{
	if ($autocheck)
	{
		$status=&checkurl;
		$status="<b>Status:</b> $status";
	}
	else
	{
		$status=qq~<a href="javascript:opwin('$url')"><b>Check Status</b></a>~;
	}
	if ($accstatus==1)
	{
		$result.=qq~<tr><td width="100%"><font face="Arial" size="2"><b>Site:</b> $sname<br><b>URL:</b> <a href="$url" target="_blank">$url</a><br><b>E-mail:</b> <a href="mailto:$uemail">$uemail</a><br><b>Description:</b> $sdescr<br>Account status: Enabled<br>$status</font><form action="$cgi/rwowner.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="user" value="$suid"><center><input type=submit name=method value=disable><input type=submit name=method value=delete></center></form></td></tr>\n~;
	}
	elsif ($accstatus==2)
	{
		$result.=qq~<tr><td width="100%"><font face="Arial" size="2"><b>Site:</b> $sname<br><b>URL:</b> <a href="$url" target="_blank">$url</a><br><b>E-mail:</b> <a href="mailto:$uemail">$uemail</a><br><b>Description:</b> $sdescr<br>Account status: Disabled<br>$status</font><form action="$cgi/rwowner.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="user" value="$suid"><center><input type=submit name=method value=enable><input type=submit name=method value=delete></center></form></td></tr>\n~;
	}
	elsif ($accstatus==3)
	{
		$result.=qq~<tr><td width="100%"><font face="Arial" size="2"><b>Site:</b> $sname<br><b>URL:</b> <a href="$url" target="_blank">$url</a><br><b>E-mail:</b> <a href="mailto:$uemail">$uemail</a><br><b>Description:</b> $sdescr<br>Account status: Suspended<br>$status</font><form action="$cgi/rwowner.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="user" value="$suid"><center><input type=submit name=method value=delete></center></form></td></tr>\n~;
	}
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$result="<tr><td align=center><font size=2>No sites</font></td></tr>\n" if (!$result);
&closedb;
open(F,"<$rwpath/template/owner.tpl");
@html=<F>;
close(F);
$html=join("",@html);
$html="print qq~$html~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $html;
exit;
}
sub delete
{
if ($data{user})
{
$sth=$dbh->query("LOCK TABLES rw_sites READ, rw_rings READ") if ($locktables);
$sth=$dbh->query("SELECT rid,rname FROM rw_rings WHERE uid=$uid");
($rid,$rname)=$sth->fetchrow;
$sth=$dbh->query("SELECT sid FROM rw_sites WHERE (uid=$data{user} AND rid=$rid)");
$sid=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if ($sid)
{
	$sth=$dbh->query("LOCK TABLES rw_users WRITE, rw_sites WRITE") if ($locktables);
	$sth=$dbh->query("SELECT email,name FROM rw_users WHERE uid=$data{user}");
	($uemail,$uname)=$sth->fetchrow;
	$sth=$dbh->query("DELETE FROM rw_users WHERE uid=$data{user}");
	$sth=$dbh->query("DELETE FROM rw_sites WHERE uid=$data{user}");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
open (MAIL,"|$mailprog");
print MAIL "To: $uemail ($uname)\n";
print MAIL "From: $email ($ownername)\n";
print MAIL "Subject: Alert\n\n";
$ltime=scalar localtime;
$sth=$dbh->query("LOCK TABLES rw_settings READ") if ($locktables);
$sth=$dbh->query("SELECT leader_site_remove,mail_header,mail_footer FROM rw_settings");
($text,$header,$footer)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$text="print MAIL \"$text\";";
print MAIL "$header\n";
eval $text;
print MAIL "$footer\n";
print MAIL "\n.\n";
close (MAIL);
}
&webexist;
}
sub disable
{
if ($data{user})
{
$sth=$dbh->query("LOCK TABLES rw_sites READ, rw_rings READ") if ($locktables);
$sth=$dbh->query("SELECT rid,rname FROM rw_rings WHERE uid=$uid");
($rid,$rname)=$sth->fetchrow;
$sth=$dbh->query("SELECT sid FROM rw_sites WHERE (uid=$data{user} AND rid=$rid)");
$sid=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if ($sid)
{
	$sth=$dbh->query("LOCK TABLES rw_users WRITE") if ($locktables);
	$sth=$dbh->query("UPDATE rw_users SET status=2 WHERE uid=$data{user}");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
$sth=$dbh->query("LOCK TABLES rw_users READ") if ($locktables);
$sth=$dbh->query("SELECT email,name FROM rw_users WHERE uid=$data{user}");
($uemail,$uname)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
open (MAIL,"|$mailprog");
print MAIL "To: $uemail ($uname)\n";
print MAIL "From: $email ($ownername)\n";
print MAIL "Subject: Site Disabled\n\n";
$ltime=scalar localtime;
$sth=$dbh->query("LOCK TABLES rw_settings READ") if ($locktables);
$sth=$dbh->query("SELECT leader_site_disable,mail_header,mail_footer FROM rw_settings");
($text,$header,$footer)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$text="print MAIL \"$text\";";
print MAIL "$header\n";
eval $text;
print MAIL "$footer\n";
print MAIL "\n.\n";
close (MAIL);
}
&webexist;
}
sub enable
{
if ($data{user})
{
$sth=$dbh->query("LOCK TABLES rw_sites READ, rw_rings READ") if ($locktables);
$sth=$dbh->query("SELECT rid,rname FROM rw_rings WHERE uid=$uid");
($rid,$rname)=$sth->fetchrow;
$sth=$dbh->query("SELECT sid FROM rw_sites WHERE (uid=$data{user} AND rid=$rid)");
$sid=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if ($sid)
{
	$sth=$dbh->query("LOCK TABLES rw_users WRITE") if ($locktables);
	$sth=$dbh->query("UPDATE rw_users SET status=1 WHERE uid=$data{user}");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
$sth=$dbh->query("LOCK TABLES rw_users READ") if ($locktables);
$sth=$dbh->query("SELECT email,name FROM rw_users WHERE uid=$data{user}");
($uemail,$uname)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
open (MAIL,"|$mailprog");
print MAIL "To: $uemail ($uname)\n";
print MAIL "From: $email ($ownername)\n";
print MAIL "Subject: Site Enabled\n\n";
$ltime=scalar localtime;
$sth=$dbh->query("LOCK TABLES rw_settings READ") if ($locktables);
$sth=$dbh->query("SELECT leader_site_enable,mail_header,mail_footer FROM rw_settings");
($text,$header,$footer)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$text="print MAIL \"$text\";";
print MAIL "$header\n";
eval $text;
print MAIL "$footer\n";
print MAIL "\n.\n";
close (MAIL);
}
&webexist;
}
sub list
{
$selected{list}="selected";
$sth=$dbh->query("LOCK TABLES rw_rings READ") if ($locktables);
$sth=$dbh->query("SELECT rid FROM rw_rings WHERE uid=$uid");
$rid=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES rw_sites READ, rw_users READ") if ($locktables);
$sth=$dbh->query("SELECT rw_sites.uid,sname,surl,sdescr,email,status FROM rw_sites,rw_users WHERE (rid=$rid AND (status=1 OR status=2 OR status=3) AND rw_sites.uid=rw_users.uid)");
while (($suid,$sname,$url,$sdescr,$uemail,$iflg)=$sth->fetchrow)
{
	if ($iflg==1){$status="Enabled";$addmod=qq~<input type=submit name=method value=Disable>~;}
	elsif ($iflg==2){$status="Disabled";$addmod=qq~<input type=submit name=method value=Enable>~;}
	else {$status="Suspended";}
	$result.=qq~<tr><td width="100%"><font face="Arial" size="2"><b>Site:</b> $sname<br><b>Status:</b> $status<br><b>Description:</b> $sdescr<br><b>URL:</b> <a href="$url" target="_blank">$url</a><br><b>Email:</b> <a href="mailto:$uemail">$uemail</a></font><form action="$cgi/rwowner.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="user" value="$suid"><center><input type=submit name=method value=edit><input type=submit name=method value=remove>$addmod</center></form></td></tr>\n~;
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&closedb;
open(F,"<$rwpath/template/owner.tpl");
@html=<F>;
close(F);
$html=join("",@html);
$html="print qq~$html~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $html;
exit;
}
sub Enable
{
if ($data{user})
{
$sth=$dbh->query("LOCK TABLES rw_sites READ, rw_rings READ") if ($locktables);
$sth=$dbh->query("SELECT rid,rname FROM rw_rings WHERE uid=$uid");
($rid,$rname)=$sth->fetchrow;
$sth=$dbh->query("SELECT sid FROM rw_sites WHERE (uid=$data{user} AND rid=$rid)");
$sid=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if ($sid)
{
	$sth=$dbh->query("LOCK TABLES rw_users WRITE") if ($locktables);
	$sth=$dbh->query("UPDATE rw_users SET status=1 WHERE uid=$data{user}");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
$sth=$dbh->query("LOCK TABLES rw_users READ") if ($locktables);
$sth=$dbh->query("SELECT email,name FROM rw_users WHERE uid=$data{user}");
($uemail,$uname)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
open (MAIL,"|$mailprog");
print MAIL "To: $uemail ($uname)\n";
print MAIL "From: $email ($ownername)\n";
print MAIL "Subject: Site Enabled\n\n";
$ltime=scalar localtime;
$sth=$dbh->query("LOCK TABLES rw_settings READ") if ($locktables);
$sth=$dbh->query("SELECT leader_site_enable,mail_header,mail_footer FROM rw_settings");
($text,$header,$footer)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$text="print MAIL \"$text\";";
print MAIL "$header\n";
eval $text;
print MAIL "$footer\n";
print MAIL "\n.\n";
close (MAIL);
}
&list;
}
sub Disable
{
if ($data{user})
{
$sth=$dbh->query("LOCK TABLES rw_sites READ, rw_rings READ") if ($locktables);
$sth=$dbh->query("SELECT rid,rname FROM rw_rings WHERE uid=$uid");
($rid,$rname)=$sth->fetchrow;
$sth=$dbh->query("SELECT sid FROM rw_sites WHERE (uid=$data{user} AND rid=$rid)");
$sid=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if ($sid)
{
	$sth=$dbh->query("LOCK TABLES rw_users WRITE") if ($locktables);
	$sth=$dbh->query("UPDATE rw_users SET status=2 WHERE uid=$data{user}");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
$sth=$dbh->query("LOCK TABLES rw_users READ") if ($locktables);
$sth=$dbh->query("SELECT email,name FROM rw_users WHERE uid=$data{user}");
($uemail,$uname)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
open (MAIL,"|$mailprog");
print MAIL "To: $uemail ($uname)\n";
print MAIL "From: $email ($ownername)\n";
print MAIL "Subject: Site Disabled\n\n";
$ltime=scalar localtime;
$sth=$dbh->query("LOCK TABLES rw_settings READ") if ($locktables);
$sth=$dbh->query("SELECT leader_site_disable,mail_header,mail_footer FROM rw_settings");
($text,$header,$footer)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$text="print MAIL \"$text\";";
print MAIL "$header\n";
eval $text;
print MAIL "$footer\n";
print MAIL "\n.\n";
close (MAIL);
}
&list;
}
sub accept
{
if ($data{user})
{
$sth=$dbh->query("LOCK TABLES rw_sites READ, rw_rings READ") if ($locktables);
$sth=$dbh->query("SELECT rid,rname FROM rw_rings WHERE uid=$uid");
($rid,$rname)=$sth->fetchrow;
$sth=$dbh->query("SELECT sid FROM rw_sites WHERE (uid=$data{user} AND rid=$rid)");
$sid=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if ($sid)
{
	$sth=$dbh->query("LOCK TABLES rw_users WRITE") if ($locktables);
	$sth=$dbh->query("UPDATE rw_users SET status=1 WHERE uid=$data{user}");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
$sth=$dbh->query("LOCK TABLES rw_users READ") if ($locktables);
$sth=$dbh->query("SELECT email,name FROM rw_users WHERE uid=$data{user}");
($uemail,$uname)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
open (MAIL,"|$mailprog");
print MAIL "To: $uemail ($uname)\n";
print MAIL "From: $email ($ownername)\n";
print MAIL "Subject: Site Accepted\n\n";
$ltime=scalar localtime;
$sth=$dbh->query("LOCK TABLES rw_settings READ") if ($locktables);
$sth=$dbh->query("SELECT leader_site_accept,mail_header,mail_footer FROM rw_settings");
($text,$header,$footer)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$text="print MAIL \"$text\";";
print MAIL "$header\n";
eval $text;
print MAIL "$footer\n";
print MAIL "\n.\n";
close (MAIL);
}
&webnew;
}
sub decline
{
if ($data{user})
{
$sth=$dbh->query("LOCK TABLES rw_sites READ, rw_rings READ") if ($locktables);
$sth=$dbh->query("SELECT rid,rname FROM rw_rings WHERE uid=$uid");
($rid,$rname)=$sth->fetchrow;
$sth=$dbh->query("SELECT sid FROM rw_sites WHERE (uid=$data{user} AND rid=$rid)");
$sid=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if ($sid)
{
	$sth=$dbh->query("LOCK TABLES rw_users WRITE, rw_sites WRITE") if ($locktables);
	$sth=$dbh->query("SELECT email,name FROM rw_users WHERE uid=$data{user}");
	($uemail,$uname)=$sth->fetchrow;
	$sth=$dbh->query("DELETE FROM rw_users WHERE uid=$data{user}");
	$sth=$dbh->query("DELETE FROM rw_sites WHERE uid=$data{user}");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
open (MAIL,"|$mailprog");
print MAIL "To: $uemail ($uname)\n";
print MAIL "From: $email ($ownername)\n";
print MAIL "Subject: Site Declined\n\n";
$ltime=scalar localtime;
$sth=$dbh->query("LOCK TABLES rw_settings READ") if ($locktables);
$sth=$dbh->query("SELECT leader_site_decline,mail_header,mail_footer FROM rw_settings");
($text,$header,$footer)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$text="print MAIL \"$text\";";
print MAIL "$header\n";
eval $text;
print MAIL "$footer\n";
print MAIL "\n.\n";
close (MAIL);
}
&webnew;
}
sub maillist
{
$selected{maillist}="selected";
$sth=$dbh->query("LOCK TABLES rw_rings READ") if ($locktables);
$sth=$dbh->query("SELECT rid,rname FROM rw_rings WHERE uid=$uid");
($rid,$fullrn)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if (-e "$messpath/$uid.msg")
{
	($atime,$mtime)=(stat("$messpath/$uid.msg"))[8,9];
	($day,$month,$date,$time,$year)=split(" ",scalar localtime($mtime));
$result=qq~
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>LAST MESSAGE</center></font></td></tr>
<tr><td width="100%"><form action="$cgi/rwowner.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="restore_message">
<font size="2">Has been sent on $date $month $year $time
<center><input type="Submit" value="Restore message"></center><br></font></form></td></tr>
~;
}
$result.=qq~
<tr><td width="100%" bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>MAILLIST</center></font></td></tr>
<tr><td width="100%"><form action="$cgi/rwowner.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="sendmail">
<font size="2">Recepients: <select name="recepient">
<option value="ringleader">All Ringleaders</option>
<option value="$rid">$fullrn members</option>
</select><br>
Subject: <input type="text" name="subject" size=54 maxlength=100 value="$subject"><br>
<textarea name="body" cols=47 rows=5>
$body
</textarea>
<center><input type="Submit" value="Send mail"></center><br></font></form></td></tr>
~;
&closedb;
open(F,"<$rwpath/template/owner.tpl");
@html=<F>;
close(F);
$html=join("",@html);
$html="print qq~$html~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $html;
exit;
}
sub restore_message
{
open(F,"$messpath/$uid.msg");
@file=<F>;
close(F);
$file=join("",@file);
($header,@body)=split("\n\n",$file);
$body=join("\n\n",@body);
@header=split("\n",$header);
$subject=$header[1];
$subject=~s/^Subject: //;
&maillist;
}
sub sendmail
{
$selected{maillist}="selected";
$count=0;
$sth=$dbh->query("LOCK TABLES rw_users READ") if ($locktables);
$sth=$dbh->query("SELECT DISTINCT email,name FROM rw_users WHERE uid=$uid");
($data{sender},$data{senname})=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES rw_rings READ") if ($locktables);
$sth=$dbh->query("SELECT DISTINCT rid,rname FROM rw_rings WHERE uid=$uid");
($rid,$rname)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$data{sender}.=" ($data{senname})";
$data{senname}.=" ($rname Ringleader)";
$data{body}=~s/\r//g;
open(MAIL,">$messpath/$uid.msg");
print MAIL "From: $data{sender}\n";
print MAIL "Subject: $data{subject}\n\n";
$ltime=scalar localtime;
$sth=$dbh->query("LOCK TABLES rw_settings READ") if ($locktables);
$sth=$dbh->query("SELECT mail_header,mail_footer FROM rw_settings");
($header,$footer)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
print MAIL "$header\n";
print MAIL "Its not spam, but $title (RingWorld Home) Newsletter $ltime\n";
print MAIL "From: $data{senname}\n\n";
print MAIL "-" x 75 . "\n\n";
print MAIL "$data{body}\n\n";
print MAIL "$footer\n";
close(MAIL);
srand;
$randnum=rand;
$result=qq~<tr><td align=center><font size=2>Sending newsletter...</font></td></tr>
<script type="text/javascript" language="Javascript">
window.open("$cgi/nph-rwmmail.pl?method=maillist&recepient=$data{recepient}&name=$data{name}&password=$data{password}&randnum=$randnum", 'f', 'toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=no,resizable=no,width=113,height=135');
</script>
~;
&closedb;
open(F,"<$rwpath/template/owner.tpl");
@html=<F>;
close(F);
$html=join("",@html);
$html="print qq~$html~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $html;
exit;
}
sub error
{
@errors=@_;
&closedb;
open(F,"<$rwpath/template/error.tpl");
@html=<F>;
close(F);
$html=join("",@html);
$html="print qq~$html~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $html;
exit;
}	
sub checkurl
{
$sockaddr = 'S n a4 x8';
$server=$url;
$server=~s/http:\/\///i;
$url.="/" unless ($url=~/\/$/ || $url=~/\.html$/ || $url=~/\.htm$/ || $url=~/\.shtml$/ || $url=~/\.phtml$/);
($server,@garbage)=split("/",$server);
return ("Internal server error") unless (socket(S,PF_INET,SOCK_STREAM,(getprotobyname('tcp'))[2]));
$farg=sockaddr_in(80,inet_aton($server));
return ("Server is down") unless (connect(S,$farg));
$message="GET $url HTTP/1.0\n\n";
$len=length($message);
syswrite(S,$message,$len);
@html=<S>;
close(S);
unless ($html[0]=~/200/){return ("Dead link");}
$html=join("",@html);
return ("No webring code") unless ($html=~/\<\!--begin $title code--\>/i);
return ("Site OK, webring code OK");
}
sub checkurl2
{
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
$sockaddr = 'S n a4 x8';
$server=$data{url};
$url=$data{url};
$server=~s/http:\/\///i;
$url.="/" unless ($url=~/\/$/ || $url=~/\.html$/ || $url=~/\.htm$/ || $url=~/\.shtml$/ || $url=~/\.phtml$/);
($server,@garbage)=split("/",$server);
return ("Internal server error") unless (socket(S,PF_INET,SOCK_STREAM,(getprotobyname('tcp'))[2]));
$farg=sockaddr_in(80,inet_aton($server));
unless (connect(S,$farg)) {print "Server is down";&closedb;exit;};
$message="GET $url HTTP/1.0\n\n";
$len=length($message);
syswrite(S,$message,$len);
@html=<S>;
close(S);
unless ($html[0]=~/200/){print "Dead link";&closedb;exit;}
$html=join("",@html);
unless ($html=~/\<\!--begin $title code--\>/i){print "No webring code";&closedb;exit;}
&closedb;
print "Site OK, webring code OK";
exit;
}
sub code
{
$selected{code}="selected";
$sth=$dbh->query("LOCK TABLES rw_rings READ") if ($locktables);
$sth=$dbh->query("SELECT rid,hcode,rname FROM rw_rings WHERE uid=$uid");
($rid,$htmlcode,$fullrn)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$htmlcode=$data{htmlcode} if ($data{method} eq "Preview");
$currentcode=$htmlcode;
$currentcode=~s/\~/\\\~/g;
eval "\$currentcode=qq~$currentcode~;";
$result=qq~<tr><td align=center><font size=2>
<form action="$cgi/rwowner.pl" method=post>
<input type="hidden" name="name" value="$data{name}">
<input type="hidden" name="password" value="$data{password}">
Here you can modify design for HTML code or your WebRing. Dont place this code to HTML page<br>
<textarea name=htmlcode cols=40 rows=6>$htmlcode</textarea><br>
<input type=submit name=method value=Recover><input type=submit name=method value=Preview><input type=submit name=method value=Save>
</form>
Looks like:<br>
$currentcode<br>
</font></td></tr>~;
&closedb;
open(F,"<$rwpath/template/owner.tpl");
@html=<F>;
close(F);
$html=join("",@html);
$html="print qq~$html~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $html;
exit;
}
sub Recover
{
$sth=$dbh->query("LOCK TABLES rw_rings WRITE, rw_settings READ") if ($locktables);
$sth=$dbh->query("SELECT hcode FROM rw_settings");
$htmlcode=$sth->fetchrow;
$sth=$dbh->query("UPDATE rw_rings SET hcode='$htmlcode' WHERE uid=$uid");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&code;
}
sub Preview
{
$data{htmlcode}=~s/\r\n//g;
&code;
}
sub Save
{
$data{htmlcode}=~s/\r\n//g;
$data{htmlcode}=~s/'/\\'/g;
$sth=$dbh->query("LOCK TABLES rw_rings WRITE") if ($locktables);
$sth=$dbh->query("UPDATE rw_rings SET hcode='$data{htmlcode}' WHERE uid=$uid");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&code;
}
sub logoremove
{
$sth=$dbh->query("LOCK TABLES rw_rings READ") if ($locktables);
$sth=$dbh->query("SELECT rid FROM rw_rings WHERE (uid=$uid)");
$rid=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
unlink("$rwpath/logo/$rid.gif");
&logo;
}
sub sort
{
$selected{sort}="selected";
$sth=$dbh->query("LOCK TABLES rw_rings READ") if ($locktables);
$sth=$dbh->query("SELECT stype FROM rw_rings WHERE uid=$uid");
$stype=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$selected[$stype]="selected";
$result=qq~
<tr><td><form action="$cgi/rwowner.pl" method="post"><input type="hidden" name="name" value="$data{name}"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="resort">
<table cellpadding=0 cellspacing=0 width="100%">
<tr><td width="100%" colspan=2 bgcolor="#CECE00"><font face="Arial" size="2" color="#000000"><center>SORT SITELIST</center></font></td></tr>
<tr><td><font face="Arial" size="2">Sort type</font></td><td><font face="Arial" size="2"><select name=stype><option value=1 $selected[1]>Randomly</option><option value=2 $selected[2]>Alphabetically</option></select></font></td></tr>
<tr><td width="100%" colspan=2 align="right"><input type="Submit" name="Submit" value="Set"></td></tr>
</table></form></td></tr>
<tr><td>
~;
&closedb;
open(F,"<$rwpath/template/owner.tpl");
@html=<F>;
close(F);
$html=join("",@html);
$html="print qq~$html~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $html;
exit;
}
sub resort
{
if ($data{stype})
{
$sth=$dbh->query("LOCK TABLES rw_rings WRITE") if ($locktables);
$sth=$dbh->query("UPDATE rw_rings SET stype=$data{stype} WHERE uid=$uid");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
&sort;
}
sub logout
{
&closedb;
print "HTTP/1.0 302 Found\n" if ($sysid eq "Windows");
print "Location: $furl\n\n";
}
sub closedb
{
$sth="";
$dbh="";
}
