#!/usr/bin/perl
use Mysql;

#    RingWorld SQL v1.9 - webring management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

# Variables Section
open (F, "<rworld.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);

($farg,$sarg)=split("&",$ENV{QUERY_STRING});
($webring)=$farg=~/=(.+)/;
($receiver)=$sarg=~/=(.+)/;
$receiver=~s/%([0-9a-fA-F]{2})/pack('C',hex($1))/eg;
unless ($receiver=~/.+\@.+/)
{
	push (@errors,"Your <b>e-mail</b> is incorrect. Please check and resubmit your request.<br>\n");
	&error(@errors);
}
if ($webring)
{
$sth=$dbh->query("LOCK TABLES rw_rings READ, rw_users READ") if ($locktables);
$sth=$dbh->query("SELECT rname,stype,rurl,name,email FROM rw_rings,rw_users WHERE (rid=$webring AND rw_users.uid=rw_rings.uid)");
($fullrn,$stype,$wurl,$name,$email)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if ($fullrn)
{
$sth=$dbh->query("LOCK TABLES rw_users READ, rw_sites READ") if ($locktables);
$sth=$dbh->query("SELECT sname,sdescr,surl FROM rw_sites,rw_users WHERE (rid=$webring AND rw_sites.uid=rw_users.uid AND status=1) ORDER BY sname");
while (($tit,$desc,$uurl)=$sth->fetchrow)
{
	$desc=~s/<br>/\n/g;
	push(@ndata,"Title: $tit\nURL: $uurl\nDescription: $desc\n\n");
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
@data=@ndata;
}
else
{
	push (@errors,"<li>Sorry, webring is not longer exist</li>\n");
	&error(@errors);
}
}
else
{
	push (@errors,"<li>Sorry, webring is not longer exist</li>\n");
	&error(@errors);
}
$ddta=join("",@data);
open (MAIL,"|$mailprog");
print MAIL "To: $receiver\n";
print MAIL "From: $email ($name)\n";
print MAIL "Subject: SiteList From RingWorld\n\n";
$ltime=scalar localtime;
$sth=$dbh->query("LOCK TABLES rw_settings READ") if ($locktables);
$sth=$dbh->query("SELECT sitelist,mail_header,mail_footer FROM rw_settings");
($text,$header,$footer)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$text="print MAIL \"$text\";";
print MAIL "$header\n";
eval $text;
print MAIL "$footer\n";
print MAIL "\n.\n";
close (MAIL);
&closedb;
open(F,"<$rwpath/template/success.tpl");
@html=<F>;
close(F);
$successmsg="Sitelist is emailed to you. Check out your e-mail box.";
$html=join("",@html);
$html="print qq~$html~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $html;


sub error
{
	@error=@_;
	&closedb;
	open(F,"<$rwpath/template/error.tpl");
	@html=<F>;
	close(F);
	$html=join("",@html);
	$html="print qq~$html~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $html;
        exit;
}
sub closedb
{
$sth="";
$dbh="";
}
